#!/usr/bin/perl -w
# author: Hari Hendaryanto <hari.h -at- csmcom.com>

use strict;
use warnings;
use Sys::Syslog qw(:DEFAULT setlogsock);
use Net::DNS;
use Net::CIDR;
use Net::CIDR ':all';
my $dns = new Net::DNS::Resolver;
#
# our transports array, we will define this in master.cf as transport services
#
our @cidr_list;
@cidr_list=Net::CIDR::cidradd("31.6.XX.0/26");
#@cidr_list=Net::CIDR::cidradd("31.6.XX.35/28", @cidr_list);

our @array = (
'smtp1:',
'smtp2:',
'smtp3:',
'smtp4:',
'smtp5:',
'smtp6:',
'smtp7:',
'smtp8:',
'smtp9:',
'smtp10:'
);

#
# Initalize and open syslog.
#
openlog('postfix/randomizer','pid','mail');

#
# Autoflush standard output.
#
select STDOUT; $|++;
while (<>) {
        chomp;
        # randomizing transports array
        my $random_smtp = int(rand(scalar(@array)));
        if (/^get\s(.+)$/i) {
		my $local_domain = $1;
                $local_domain =~ s/.*\@//i;

		    my $mx = $dns->send( $local_domain, 'MX' );
		    my $a;
		    my $is_local = 0;
		    my $arr;
		    if ($mx){
		    	foreach my $rr ($mx->answer) {
				next unless $rr->type eq "MX";
				$a = $dns->send( $rr->exchange, 'A' );
				foreach $arr ($a->answer) {			
					next unless $arr->type eq "A";
					if(Net::CIDR::cidrlookup($arr->address, @cidr_list)==1){
						$is_local = 1;
					}
					last;	
				}
				last;
		    	}
		    }	    

		if ($is_local == 1){
			print "200 dovecot:\n";
			#syslog("info","Using: %s Transport Service", $local_domain);
		} else {
                        print "200 $array[$random_smtp]\n";
                        #syslog("info","Using: %s Transport Service", $random_smtp);
                }
                next;
        }

    print "200 smtp:";
}
